# Rust web-ohjelmointikielenä

Opinnäytetyön tavoitteena on selvittää Rust-ohjelmointikielen soveltuvuutta web-ohjelmointiin.

Opinnäytetyön yhteydessä tarkoituksena tehdä suhteellisen pieni projekti, missä frontend ja backend toteutetaan molemmat Rustilla.

Rust on Mozillan 2010 julkaisema ohjelmointikieli. Se on hyvin suorituskykyinen järjestelmätason ohjelmointikieli, muistuttaen monilta osin C ja C++ kieliä. Rustin tarkoituksena on säilyttää näiden vanhojen kielien suorituskyky, mutta kuitenkin tarjoten samalla muun muassa vahvan tyypityksen, ratkaista tyypilliset C-kielien muistinhallintaongelmat, turvallisen rinnakkaisajon.

Lisäksi Rust kokoontuu suoraan WebAssemblyksi, mikä on omalta osaltaan kerännyt kanssa hyvin paljon kiinnostusta lähivuosina. Sitä on suunniteltu JavaScriptin seuraajaksi ja sen etuna on Rustin tavoin huomattavasti parempi tehokkuus ja suorituskyky.

Opinnäytetyön projektissa olen suunnitellut käyttäväni Yew frameworkiä, mikä on juuri Rustilla toteutettu ja kokoontuu WebAssemblyksi. Lisää tietoa siitä voi lukea täältä https://yew.rs

Backend puolella tulen käyttämään todennäköisesti Actixia, siitä lisää tietoa täältä: https://actix.rs

Itse projektin aihe on vielä vähän auki, mutta projektin lopputulos ei olekaan tässä se tärkein, vaan Rustin arviointi web-kehityksen työkaluna.
